import os, urllib2, re
from BeautifulSoup import BeautifulSoup

u = urllib2.urlopen('http://www.bbc.co.uk/radio/aod/availability/worldservice.xml')
xmldata = u.read()
u.close()

bs = BeautifulSoup(xmldata)
del xmldata

lst_entries = bs.findAll('entry', text=re.compile('The latest five minute news bulletin from BBC World Service'))

lst = []

for item in lst_entries:
    entry = item.parent.parent
    version_pid = entry.broadcast['version_pid']
    itemname = 'res\\BBC_News_%s_%s.flv' % (entry.broadcast['start'].replace('-','').replace('T','_')[:11],entry.pid.text)
    print version_pid, itemname
    lst.append([version_pid, itemname])

del bs

for id, fname in lst:
    if os.path.exists(fname): continue
    url = 'http://www.bbc.co.uk/mediaselector/4/mtis/stream/%s' % (id)

    u = urllib2.urlopen(url)
    data = u.read()
    u.close()

    if data.find('<error id="notavailable"/>') > -1:
        print 'not available'
        continue

    d=re.search('<connection ([^<]+) supplier="akamai"/>',data).group()
    server = re.search('server="([^\s]+)"',d).group(1)
    playpath = re.search('identifier="([^\s]+)"',d).group(1)

    cmd = "rtmpdump -r rtmp://%s -a ondemand --playpath %s --flv %s" % (server,playpath,fname)

    os.system(cmd)